;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************











opcode_CMP:

opc_CMP_1:
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CMP_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop

opcode_CMP_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CMP_ZPX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CMP_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CMP_Abs_X:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop
opcode_CMP_Abs_Y:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_Y
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CMP_InX:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_InX
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop

opcode_CMP_InY:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_InY
			cp reg_A, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop





opcode_CPX:

opc_CPX_1:


opcode_CPX_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2
			cp reg_X, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop

opcode_CPX_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP
			cp reg_X, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CPX_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			cp reg_X, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CPY:

opc_CPY_1:
			cp reg_Y, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop

opcode_CPY_immed:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM oparand		;6
			adiw SyncL, 2*MHz				;2
			cp reg_Y, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CPY_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP
			cp reg_Y, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop


opcode_CPY_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			cp reg_Y, oparand
			in temp, SREG
			andi reg_Status, 0b11111000
			andi temp, 0b00000111
			or reg_Status, temp
			rjmp main_loop






opcode_BIT:

	opc_BIT_1:


opcode_BIT_ZP:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP
			tst oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			bst oparand, 0x06
			bld reg_Status, flagV			; oder entspricht AVR-V 6502-V???
			rjmp main_loop


opcode_BIT_Abs:
			movw ZL, reg_PCL		; Z wieder als PC
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute
			tst oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			bst oparand, 0x06
			bld reg_Status, flagV			; oder entspricht AVR-V 6502-V???
			rjmp main_loop



















