;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************


opcode_PHP:
			movw ZL, reg_PCL
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero
			mov temp, reg_Status2
			mov temp2, reg_Status
			andi temp2, 0b00000011
			or temp2, temp
			bld reg_Status, 0x02
			bst temp2, 0x07
			bld reg_Status, 0x03
			bst temp2, 0x06
			; I-Flag aus IO auslesen???
			mov YL, reg_SP
			dec reg_SP
			ldi YH, 0x01
			st Y, temp2
			rjmp main_loop



opcode_PLP:
			movw ZL, reg_PCL
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero
			inc reg_SP
			mov YL, reg_SP
			ldi YH, 0x01
			ld reg_Status2, Y
			mov reg_Status, temp
			andi reg_Status, 0b00000011
			bld reg_Status2, 0x07
			bst reg_Status, 0x02
			bld reg_Status2, 0x06
			bst reg_Status, 0x03
			andi reg_Status2, 0b00011100
			rjmp main_loop





opcode_PHA:
			movw ZL, reg_PCL
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero

			mov YL, reg_SP
			ldi YH, 0x01
		
			st Y, reg_A
			dec reg_SP

			rjmp main_loop
opcode_PLA:
			movw ZL, reg_PCL
			ldi loop, 4*MHz
			add SyncL, loop
			adc SyncH, zero

			inc reg_SP
			mov YL, reg_SP
			ldi temp, 0x01
			ld reg_A, Y
			rjmp main_loop
opcode_TXS:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz				;2
			mov reg_SP, reg_X
			rjmp main_loop

opcode_TSX:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz				;2
			mov reg_X, reg_SP
			rjmp main_loop
