;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************






; Der Interrupt msste noch einen Zyklus vorher abgefragt werden
; mir ist noch unklar, wieviele Zyklen bei IRQ/NMI im BRK nun anfallen
;	gelten die 7 Takte gesamt oder ab Interrupt??
opcode_BRK:
; was ist mit I_Flag????
			sbr reg_Status2, flag_B
			adiw reg_PCL, 0x01
			mov YL, reg_SP
			ldi YH, 0x01
			st Y, reg_PCH
			dec YL
			st Y, reg_PCL
			dec YL
			; Status ummodeln
			mov temp, reg_Status2
			mov temp2, reg_Status
			andi temp2, 0b00000011
			or temp2, temp
			bld reg_Status, 0x02
			bst temp2, 0x07
			bld reg_Status, 0x03
			bst temp2, 0x06
			; I-Flag aus IO auslesen???
			mov reg_SP, YL
			st Y, temp2
			dec reg_SP

			ldi loop, 4*MHz				; Rest nach IRQ
			add SyncL, loop
			adc SyncH, zero

			ldi ZL, low (Vector6510NMI)
			ldi ZH, high(Vector6510NMI)

			;**************
			;IRQ abfangen
			sei
			nop
			cli
			;ld reg_PCL, Y+
			;ld reg_PCH, Y+
			READ_RAMROM reg_PCL		;6
			READ_RAMROM reg_PCH		;6
			movw ZL, reg_PCL
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero

			rjmp main_loop




opcode_JSR:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM opbyte2		;6
			READ_RAMROM opbyte3		;6

			;ld opbyte2, X+
			;ld opbyte3, X+


			mov YL, reg_SP
			ldi YH, 0x01
			st Y, ZH
			dec reg_SP
			st -Y, ZL
			dec reg_SP
			mov ZL, opbyte2
			mov ZH, opbyte3
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rjmp main_loop









opcode_RTI:
			inc reg_SP
			mov YL, reg_SP
			ldi YH, 0x01
			ld reg_Status2, Y
			mov reg_Status, temp
			andi reg_Status, 0b00000011
			bld reg_Status2, 0x07
			bst reg_Status, 0x02
			bld reg_Status2, 0x06
			bst reg_Status, 0x03
			andi reg_Status2, 0b00011100
			inc YL
			ld ZL, Y
			inc YL
			ld ZH, Y
			mov reg_SP, YL
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rjmp main_loop








opcode_RTS:
			mov YL, reg_SP
			ldi YH, 0x01
			inc YL
			ld ZL, Y
			inc YL
			ld ZH, Y
			mov reg_SP, YL
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero

			rjmp main_loop


; erstmal nur einfach 1 Takt warten, auch bei illegalen Opcodes

opcode_NOP:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			rjmp main_loop






opcode_JMP:


			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM temp		;6
			READ_RAMROM temp2		;6

			;ld temp, X+
			;ld temp2, X+
			;mov reg_PCL, temp
			;mov reg_PCH, temp2
			mov ZL, temp
			mov ZH, temp2
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero

			rjmp main_loop


opcode_JMP_indirect:
			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM temp		;6
			READ_RAMROM temp2		;6

			mov ZL, temp
			mov ZH, temp2

			;movw YL, reg_PCL
			READ_RAMROM temp		;6
			READ_RAMROM temp2		;6
			;ld temp, Y+
			;ld temp2, Y
			mov ZL, temp
			mov ZH, temp2
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rjmp main_loop




opcode_TAY:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			mov reg_Y, reg_A
			rjmp main_loop


opcode_TYA:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			mov reg_A, reg_Y
			rjmp main_loop


opcode_TXA:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			mov reg_A, reg_X
			rjmp main_loop


opcode_TAX:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			mov reg_X, reg_A
			rjmp main_loop




; Folgendes alles 2 Takte, nur 1 byte
;		Status2:		I	D	B	S	V	-	-	-
;		Status:			-	-	-	-	-	N	Z	C

opcode_CLC:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			cbr reg_Status, flag_C
			rjmp main_loop


opcode_SEC:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			sbr reg_Status, flag_C
			rjmp main_loop



	; zum Aktivieren des IRQ auf noch entsprechendes IO-Register setzen
opcode_CLI:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			cbr reg_Status2, flag_I
			;sbi IRQMask, IRQMPin		;2
			rjmp main_loop
opcode_SEI:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			sbr reg_Status2, flag_I
			;cbi IRQMask, IRQMPin		;2
			rjmp main_loop
opcode_CLV:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			cbr reg_Status, flag_V
			rjmp main_loop
opcode_CLD:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			cbr reg_Status2, flag_D
			rjmp main_loop
opcode_SED:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			sbr reg_Status2, flag_D
			rjmp main_loop


















