;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************
; Macros mit verschiedenen Warteschleifen
; knnte das Clock-Zhlen erleichtern


.macro LOOP3
			ldi loop, @0
			dec loop
			brne pc-1
.endmacro

.macro WAIT2
			nop
			nop
.endmacro
.macro WAIT3
			nop
			nop
			nop
.endmacro
.macro WAIT4
			nop
			nop
			nop
			nop
.endmacro
.macro WAIT5
			nop
			nop
			nop
			nop
			nop
.endmacro
.macro WAIT6
			LOOP3 0x02
.endmacro
.macro WAIT7
			LOOP3 0x02
			nop
.endmacro
.macro WAIT8
			LOOP3 0x02
			nop
			nop
.endmacro
.macro WAIT9
			LOOP3 0x03
.endmacro
.macro WAIT10
			LOOP3 0x03
			nop
.endmacro
.macro WAIT11
			LOOP3 0x03
			nop
			nop
.endmacro
.macro WAIT12
			LOOP3 0x04
.endmacro
.macro WAIT13
			LOOP3 0x04
			nop
.endmacro
.macro WAIT14
			LOOP3 0x04
			nop
			nop
.endmacro
.macro WAIT15
			LOOP3 0x05
.endmacro
.macro WAIT16
			LOOP3 0x05
			nop
.endmacro
.macro WAIT17
			LOOP3 0x05
			nop
			nop
.endmacro
.macro WAIT18
			LOOP3 0x06
.endmacro
.macro WAIT19
			LOOP3 0x06
			nop
.endmacro
.macro WAIT20
			LOOP3 0x06
			nop
			nop
.endmacro
.macro WAIT21
			LOOP3 0x07
.endmacro
.macro WAIT22
			LOOP3 0x07
			nop
.endmacro
.macro WAIT23
			LOOP3 0x07
			nop
			nop
.endmacro


;***********************************************
;ab hier eigentlich Quatsch wegen der Lesezyklen
.macro WAIT24
			LOOP3 0x08
.endmacro
.macro WAIT25
			LOOP3 0x08
			nop
.endmacro
.macro WAIT26
			LOOP3 0x08
			nop
			nop
.endmacro
.macro WAIT27
			LOOP3 0x09
.endmacro
.macro WAIT28
			LOOP3 0x09
			nop
.endmacro
.macro WAIT29
			LOOP3 0x09
			nop
			nop
.endmacro


.macro RWAIT
	.if (MHZ-@0) < 0
			.error "Zuwenig Takte frei"
	.endif
	.if (MHZ-@0) >(MHZ)
			.error "mehr als ein 6502-Takt Leerlauf"
	.endif
	.if @0 == MHZ
			;nix
	.endif
	.if (MHZ-@0) == 1
			nop
	.endif
	.if (MHZ-@0) == 2
			WAIT2
	.endif
	.if (MHZ-@0) == 3
			WAIT3
	.endif
	.if (MHZ-@0) == 4
			WAIT4
	.endif
	.if (MHZ-@0) == 5
			WAIT5
	.endif
	.if (MHZ-@0) == 6
			WAIT6
	.endif
	.if (MHZ-@0) == 7
			WAIT7
	.endif
	.if (MHZ-@0) == 8
			WAIT8
	.endif
	.if (MHZ-@0) == 9
			WAIT9
	.endif
	.if (MHZ-@0) == 10
			WAIT10
	.endif
	.if (MHZ-@0) == 11
			WAIT11
	.endif
	.if (MHZ-@0) == 12
			WAIT12
	.endif
	.if (MHZ-@0) == 13
			WAIT13
	.endif
	.if (MHZ-@0) == 14
			WAIT14
	.endif
	.if (MHZ-@0) == 15
			WAIT15
	.endif
	.if (MHZ-@0) == 16
			WAIT16
	.endif
	.if (MHZ-@0) == 17
			WAIT17
	.endif
	.if (MHZ-@0) == 18
			WAIT18
	.endif
	.if (MHZ-@0) == 19
			WAIT19
	.endif
	.if (MHZ-@0) == 20
			WAIT20
	.endif
	.if (MHZ-@0) == 21
			WAIT21
	.endif
	.if (MHZ-@0) == 22
			WAIT22
	.endif
	.if (MHZ-@0) == 23
			WAIT23
	.endif
	.if (MHZ-@0) == 24
			WAIT24
	.endif



.endmacro























