;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************




/*



;Adressierungen:
Implied/immediate
(indir,x)
(indir),y
Zeropage
ZeropageX(Y)
Absolute
Absolute,X
Absolute,Y



















read_Absolute:
		;Read instructions (LDA, LDX, LDY, EOR, AND, ORA, ADC, SBC, CMP, BIT, LAX, NOP)
		; Ablauf: READ op2, READ op3, Test auf 0x0000+0x0001, Read oparand
			READ_RDY
			ld opbyte2, X+		;L-byte
			RWAIT 4

			READ_RDY
			ld opbyte3, X+		;H-byte
			WAIT4			; Ausgleich fr add+rjmp
		read_Abs_00:
			tst opbyte3
			breq read_Abs_1			; ZP-Zugriff

			RWAIT 12

			mov YL, opbyte2
			mov YH, opbyte3
			READ_RDY
			ld oparand, Y
			ijmp			;ges. 8, bleiben 9 Takte fr die Bearbeitung
		read_Abs_1:
			mov temp, opbyte2
			lsr temp
			breq read_Abs_2
			;ab hier normal ZP
			RWAIT 16
			mov YL, opbyte2
			;ldi YH, 0x00
			mov YH, ZP_Highbyte
			READ_RDY
			ld oparand, Y
			ijmp
		read_Abs_2:
			;ab hier Zugriff auf 0x0000 oder 0x0000
			tst opbyte2
			breq read_Abs_3
			RWAIT 17
			READ_RDY
			in oparand, CPU_DDR
			nop
			ijmp
		read_Abs_3:
			RWAIT 18
			READ_RDY
			in oparand, CPU_I
			nop
			ijmp


;     Read-Modify-Write instructions (ASL, LSR, ROL, ROR, INC, DEC,
;                                     SLO, SRE, RLA, RRA, ISB, DCP)
read_mod_Absolute:
	; ist eigentlich wie read_Absolute

read_mod_Absolute_Y:
;     Read-Modify-Write instructions (ASL, LSR, ROL, ROR, INC, DEC,
;                                     SLO, SRE, RLA, RRA, ISB, DCP)

read_Absolute_Y:
; wie read_Absolute, nur mit add reg_Y
;	und evtl. Artezyklus bei berlauf
;     Read instructions (LDA, LDX, LDY, EOR, AND, ORA, ADC, SBC, CMP, BIT,
;                        LAX, LAE, SHS, NOP)
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte2
			;adiw reg_PCL, 0x01
			;READ_EXT_RAM reg_PCL, reg_PCH, opbyte3
			;adiw reg_PCL, 0x01
			READ_RDY
			ld opbyte2, X+
			RWAIT 4
			READ_RDY
			ld opbyte3, X+

			add opbyte2, reg_Y
			brcs read_Abs_Y_warte1
		read_Abs_Y_0:
			rjmp read_Abs_00

		read_Abs_Y_warte1:
			;25 Takte warten inkl. Sprnge
			RWAIT 7
			READ_RDY
			WAIT2
			rjmp read_Abs_Y_0










read_mod_Absolute_X:
;     Read-Modify-Write instructions (ASL, LSR, ROL, ROR, INC, DEC,
;                                     SLO, SRE, RLA, RRA, ISB, DCP)

read_Absolute_X:
; wie read_Absolute, nur mit add reg_Y
;	und evtl. Artezyklus bei berlauf
;     Read instructions (LDA, LDX, LDY, EOR, AND, ORA, ADC, SBC, CMP, BIT,
;                        LAX, LAE, SHS, NOP)
			READ_RDY
			ld opbyte2, X+
			RWAIT 4

			READ_RDY
			ld opbyte3, X+

			add opbyte2, reg_X
			brcs read_Abs_X_warte1
		read_Abs_X_0:
			rjmp read_Abs_00


		read_Abs_X_warte1:
			;25 Takte warten inkl. Sprnge
			RWAIT 7
			READ_RDY
			nop
			nop
			rjmp read_Abs_X_0





































; ############################################################
; Versuch: Ultra-Kurz-Version
; opcodetabelle an feste Stelle im Flash (low=0x00)
main_loop0:

			sei
			ldi ZH, high(opcodes_table)
			cli
			; *************************
			; opcode lesen
			READ_RDY
			ld ZL, X+

opcode_switch0:
			;ldi ZL, low (opcodes_table)
			ldi ZH, high(opcodes_table)
			ijmp		;+rjmp = 4
		;12 Takte gesamt+2 vorher rjmp main_loop


	;SRAM-Version

			sei
			ldi YH, high(opcodes_table_SRAM)
			cli
			READ_RDY
			ld YL, X+		; opcode lesen

			ld ZL, Y+
			ld ZH, Y
			ijmp
		;13 Takte gesamt








opcode_ADC_immed0:
		; nur 2 Takte jeweils Zeit!!!
			nop
			LoadZ opc_ADC_immed_1
			rjmp read_immediate
	opc_ADC_immed_1:
			sbrc reg_Status2, flagD
			rjmp opc_ADC_Bin_1
			rjmp BCDadd









main_loop:
			sei
			nop
main_loop_IRQ:
			cli
			; *************************
			; opcode lesen
			READ_RDY
			ld opcode, X+

opcode_switch:
			ldi ZL, low (opcodes_table)
			ldi ZH, high(opcodes_table)
			nop
			add ZL, opcode
			adc ZH, zero
			nop
			nop

			ijmp			; +rjmp = 4 Takte

	; opcode-Tabelle auf glatte low-byte = 0 legen!!
	; .lst nutzen fr den genauen Wert
main_loop:
			sei
			ldi ZH, high(opcodes_table)
main_loop_IRQ:
			cli
			; *************************
			; opcode lesen
			READ_RDY
			ld ZL, X+
			ijmp
;9 statt 16 Takte!!!















			cpi ZH, ROMBASE	; test, ob RAM oder ROM
			brsh weiter
			ld opcode, Z+	
			rjmp weiter2	;6
		weiter:
			lpm opcode, Z+	;6
		weiter2:








			dec SyncCount
			brne weiter		;3Takte ohne Sync
			rcall sync
		weiter:








;Kurzer Versuch, ob ein AVR als IO-Chip verwendbar wre
; Annahme: 8-bit Daten, 4-bit Adresse, CS-Eingang, RW-Eingang
; XH = high (IO_RAM)

	;CS-Prfen
			sbic sys_port, CS_pin
			rjmp kein Zugriff

	;RW-Prfen und verzweigen nach lesen oder schreiben
			sbic sys_port, RW_pin
			rjmp write_port

	;Adresse lesen
			in XL, add_port
			ld temp, X
			out data_port, temp
			; 8 Zyklen, bis die Daten am Port bereit sind


	write_port:
			in XL, add_port
			in temp, data_port
			st X, data_port
			; Aktionen ausfhren je nach Adresse

		;7 Zyklen, bis die Daten am Port eingelesen sind







; Verschiedene Varianten des ext. Speicherzugriffs:
		; 16 Pin Add, 8 Pin Data, RW-Leitung

	read:


		out dataDDR, allout ; allout = rX ($FF)
		cbi sysport, RWpin

		out addHport, addH
		out addLport, addL
		; evtl. nop??
		in data, dataport


	write:
		out dataDDR, allin ; allin = rY ($00) = zero


		out addHport, addH
		out addLport, addL
		sbi sysport, RWpin
		out dataport, data
	; Vorteil: 4-max5 Takte je nach Speicher
	; Nachteil: mind. 25 Pins weg, nur auf dem 8515 bliebe ein voller Port





		; Hardware wie XMEM:
		; 8bit AddH, 8bit AddL+Data, RW, ALE


	read1:
		out dataDDR, allout
		cbi sysport, RWpin
		
		out dataport, addL
		sbi sysport, ALEpin
		out dataDDR, allin
		out addHport, addH
		; evtl. nop ntig?
		in dataport, data



	write1:
		out dataDDR, allout
		out dataport, addL
		sbi sysport, ALEpin
		out addHport, addH
		sbi sysport, RWpin
		out dataport, data

	; ca. 5-6 Takte 18 Pins, blieben 8+6


		; alles an einem Port ber Latches


	read2:
		out dataDDR, allout
		out dataport, addL
		sbi sysport, ALE_L_pin
		out dataport, addH
		sbi sysport, ALE_H_pin
		cbi sysport, RWpin		;?richtig hier??
		out dataDDR, allout
		in dataport, data


	write2
		out dataDDR, allout
		out dataport, addL
		sbi sysport, ALE_L_pin
		out dataport, addH
		sbi sysport, ALE_H_pin
		sbi sysport, RWpin		; evtl. Pause zum reagieren???
		out dataport, data


	; 7, vielleicht 8 Takte
	; nur 11 pins ntig







									Code	Time
opcodes_table:
rjmp opcode_BRK			;0x00
rjmp opcode_ORA_InX
rjmp opcode_INVAL		;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ORA_ZP		;			erl.
rjmp opcode_ASL_ZP		;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_PHP			;			erl.
rjmp opcode_ORA_immed	;			erl.
rjmp opcode_ASL_accu	;			erl.
rjmp opcode_SZP_immed	;			erl.		********************* neuer Opcode!!!!
rjmp opcode_NOP			;			erl.
rjmp opcode_ORA_Abs		;			erl.
rjmp opcode_ASL_Abs		;			erl.
rjmp opcode_SLO			;0x0F		erl.

rjmp opcode_BPL			;0x10		erl.
rjmp opcode_ORA_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ORA_ZPX		;			erl.
rjmp opcode_ASL_ZPX		;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_CLC			;			erl.
rjmp opcode_ORA_Abs_Y	;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_SLO			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ORA_Abs_X	;			erl.
rjmp opcode_ASL_Abs_X	;			erl.
rjmp opcode_SLO			;0x1F


rjmp opcode_JSR			;0x20
rjmp opcode_AND_InX
rjmp opcode_INVAL		;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_BIT
rjmp opcode_AND_ZP		;			erl.
rjmp opcode_ROL_ZP		;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_PLP			;			erl.
rjmp opcode_AND_immed	;			erl.
rjmp opcode_ROL_accu	;			erl.
rjmp opcode_ANC			;			erl.
rjmp opcode_BIT
rjmp opcode_AND_Abs		;			erl.
rjmp opcode_ROL_Abs		;			erl.
rjmp opcode_RLA			;0x2F		erl.


rjmp opcode_BMI			;0x30		erl.
rjmp opcode_AND_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_AND_ZPX		;			erl.
rjmp opcode_ROL_ZPX		;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_SEC			;			erl.
rjmp opcode_AND_Abs_Y	;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_RLA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_AND_Abs_X	;			erl.
rjmp opcode_ROL_Abs_X	;			erl.
rjmp opcode_RLA			;0x3F		erl.

rjmp opcode_RTI			;0x40
rjmp opcode_EOR_InX
rjmp opcode_INVAL		;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_EOR_ZP		;			erl.
rjmp opcode_LSR_ZP		;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_PHA			;			erl.
rjmp opcode_EOR_immed	;			erl.
rjmp opcode_LSR_accu	;			erl.
rjmp opcode_ASR			;			erl.
rjmp opcode_JMP
rjmp opcode_EOR_Abs		;			erl.
rjmp opcode_LSR_Abs		;			erl.
rjmp opcode_SRE			;0x4F		erl.

rjmp opcode_BVC			;0x50		erl.
rjmp opcode_EOR_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_EOR_ZPX		;			erl.
rjmp opcode_LSR_ZPX		;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_CLI			;			erl.
rjmp opcode_EOR_Abs_Y	;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_SRE			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_EOR_Abs_X	;			erl.
rjmp opcode_LSR_Abs_X	;			erl.
rjmp opcode_SRE			;0x5F		erl.

rjmp opcode_RTS			;0x60
rjmp opcode_ADC_InX
rjmp opcode_INVAL		;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ADC_ZP
rjmp opcode_ROR_ZP		;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_PLA			;			erl.
rjmp opcode_ADC_immed
rjmp opcode_ROR_accu	;			erl.
rjmp opcode_ARR			;			erl.
rjmp opcode_JMP
rjmp opcode_ADC_Abs
rjmp opcode_ROR_Abs		;			erl.
rjmp opcode_RRA			;0x6F		erl.

rjmp opcode_BVS			;0x70		erl.
rjmp opcode_ADC_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ADC_ZPX
rjmp opcode_ROR_ZP		;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_SEI			;			erl.
rjmp opcode_ADC_Abs_Y
rjmp opcode_NOP			;			erl.
rjmp opcode_RRA			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_ADC_Abs_X
rjmp opcode_ROR_Abs_X	;			erl.
rjmp opcode_RRA			;0x7F		erl.

rjmp opcode_NOP			;0x80		erl. 
rjmp opcode_STA_InX
rjmp opcode_NOP			;			erl.
rjmp opcode_SAX			;			erl.
rjmp opcode_STY_ZP		;			erl.
rjmp opcode_STA_ZP 		;			erl. 
rjmp opcode_STX_ZP		;			erl.
rjmp opcode_SAX			;			erl.
rjmp opcode_DEY			;			erl.  
rjmp opcode_NOP			;			erl. 
rjmp opcode_TXA  		;			erl.
rjmp opcode_ANE			;			erl.
rjmp opcode_STY_Abs		;			erl.  
rjmp opcode_STA_Abs		;			erl.  	OK
rjmp opcode_STX_Abs 	;			erl. 
rjmp opcode_SAX			;0x8F 

rjmp opcode_BCC			;0x90		erl.
rjmp opcode_STA_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_SHA			;			erl.
rjmp opcode_STY_ZPX		;			erl.
rjmp opcode_STA_ZPX		;			erl.
rjmp opcode_STX_ZPY		;			erl.
rjmp opcode_SAX			;			erl.
rjmp opcode_TYA			;			erl.
rjmp opcode_STA_Abs_Y	;			erl.
rjmp opcode_TXS			;			erl.
rjmp opcode_SHS			;			erl.
rjmp opcode_SHY			;			erl.
rjmp opcode_STA_Abs_X	;			erl.
rjmp opcode_SHX			;			erl.
rjmp opcode_SHA			;			erl.


rjmp opcode_LDY_immed	;0xA0		erl.	OK
rjmp opcode_LDA_InX
rjmp opcode_LDX_immed	;			erl.	OK
rjmp opcode_LAX			;			erl.
rjmp opcode_LDY_ZP		;			erl.
rjmp opcode_LDA_ZP		;			erl.
rjmp opcode_LDX_ZP		;			erl.
rjmp opcode_LAX			;			erl.
rjmp opcode_TAY			;			erl.
rjmp opcode_LDA_immed	;			erl.	OK
rjmp opcode_TAX			;			erl.
rjmp opcode_LXA			;			erl.
rjmp opcode_LDY_Abs		;			erl.
rjmp opcode_LDA_Abs		;			erl.
rjmp opcode_LDX_Abs		;			erl.
rjmp opcode_LAX			;0xAF

rjmp opcode_BCS			;0xB0
rjmp opcode_LDA
rjmp opcode_INVAL		;			erl.
rjmp opcode_LAX			;			erl.
rjmp opcode_LDY_ZPX		;			erl.
rjmp opcode_LDA_ZPX		;			erl.
rjmp opcode_LDX_ZPY		;			erl.
rjmp opcode_LAX			;			erl.
rjmp opcode_CLV			;			erl.
rjmp opcode_LDA_Abs_Y	;			erl.
rjmp opcode_TSX			;			erl.
rjmp opcode_LAS			;			erl.
rjmp opcode_LDY_Abs_X	;			erl.
rjmp opcode_LDA_Abs_X	;			erl.
rjmp opcode_LDX_Abs_Y	;			erl.
rjmp opcode_LAX			;0xBF

rjmp opcode_CPY_immed	;0xC0
rjmp opcode_CMP_InX
rjmp opcode_NOP			;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_CPY_ZP		;			erl.
rjmp opcode_CMP_ZP		;			erl.
rjmp opcode_DEC_ZP		;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_INY			;			erl.
rjmp opcode_CMP_immed	;			erl.
rjmp opcode_DEX			;			erl.
rjmp opcode_SBX			;			erl.
rjmp opcode_CPY_Abs		;			erl.
rjmp opcode_CMP_Abs		;			erl.
rjmp opcode_DEC_Abs		;			erl.
rjmp opcode_DCP			;0xCF		erl.

rjmp opcode_BNE			;0xD0		erl.
rjmp opcode_CMP_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_CMP_ZPX		;			erl.
rjmp opcode_DEC_ZPX		;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_CLD			;			erl.
rjmp opcode_CMP_Abs_Y	;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_DCP			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_CMP_Abs_X	;			erl.
rjmp opcode_DEC_Abs_X	;			erl.
rjmp opcode_DCP			;0xDF		erl.


rjmp opcode_CPX_immed	;0xE0		erl.
rjmp opcode_SBC_InX
rjmp opcode_NOP			;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_CPX_ZP		;			erl.
rjmp opcode_SBC_ZP
rjmp opcode_INC_ZP		;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_INX			;			erl.
rjmp opcode_SBC_immed
rjmp opcode_NOP			;			erl.
rjmp opcode_SBC
rjmp opcode_CPX_Abs		;			erl.
rjmp opcode_SBC_Abs
rjmp opcode_INC_Abs		;			erl.
rjmp opcode_ISB			;			erl.

rjmp opcode_BEQ			;0xF0		erl.
rjmp opcode_SBC_InY
rjmp opcode_INVAL		;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_SBC_ZPX
rjmp opcode_INC_ZPX		;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_SED			;			erl.
rjmp opcode_SBC_Abs_Y
rjmp opcode_NOP			;			erl.
rjmp opcode_ISB			;			erl.
rjmp opcode_NOP			;			erl.
rjmp opcode_SBC_Abs_X
rjmp opcode_INC_Abs_X	;			erl.
rjmp opcode_ISB			;0xFF		erl.






































*/
